{$R-}
unit VGIMenu;
interface
uses Objects,Graph,VgiLow,VgiKeys,VGIBase,VGIText;
const hcNoContext=0;
type

{ TMenu types }

  TMenuStr = string[31];

  PMenu = ^TMenu;

  PMenuItem = ^TMenuItem;
  TMenuItem = record
    Next: PMenuItem;
    Name: PString;
    Command: Integer;
    KeyCode: Word;
    HelpCtx: Word;
    case Integer of
      0: (Param: PString);
      1: (SubMenu: PMenu);
  end;

  TMenu = record
    Items: PMenuItem;
    Default: PMenuItem;
  end;
  {TMenuView - ࠪ ꥪ - }
  PMenuView = ^TMenuView;
  TMenuView = object(TVisibleObject)
    ParentMenu: PMenuView;
    Menu: PMenu;
    Current: PMenuItem;
    SubMenu:PMenuView;
    constructor Load(var S: TStream);
    {㦠   ⮪}
    function Execute: Word; virtual;
    {쭮 믮 }
    function FindItem(Code: Word): PMenuItem;
    {   뤥 㪢}
    function FindPoint(Pnt:TPoint):PMenuItem;
    {   न⠬}
    procedure GetItemRect(Item: PMenuItem; var R: TRect); virtual;
    {頥 אַ㣮쭨, ᮢ ண ॡ}
    function GetHelpCtx: Word; virtual;
    {頥 Help Context}
    Function Handle(Code: Word):integer; virtual;
    {ࠡ뢠 ᮡ}
    function HotKey(KeyCode: Word): PMenuItem;
    {   祩 }
    function NewSubView(X1,Y1:Integer; AMenu: PMenu;
      AParentMenu: PMenuView): PMenuView; virtual;
    procedure OpenSubMenu;
    {뢠  }
    procedure Store(var S: TStream);
    {   ⮪}
    Function isBar:Boolean;virtual;
    Function SelectItem(Item:PMenuItem):Integer;
    function TopMenu:PMenuView;
    Function GetItemByCommand(ACommand:Integer):PMenuItem;

  end;
 {TMenubar -   }
  PMenuBar = ^TMenuBar;
  TMenuBar = object(TMenuView)
    constructor Init(X1,Y1,X2,Y2:Integer; AMenu: PMenu);
    destructor Done; virtual;
    procedure Draw; virtual;
    procedure GetItemRect(Item: PMenuItem; var R: TRect); virtual;
    Function isBar:Boolean;virtual;
  end;

{ TMenuBox Pull-Down menu }

  PMenuBox = ^TMenuBox;
  TMenuBox = object(TMenuView)
    SavePtr:PImage;
    Visible:Boolean;
    constructor Init(X1,Y1:Integer; AMenu: PMenu;
      AParentMenu: PMenuView);
    Destructor Done;virtual;
    procedure Draw; virtual;
    Procedure Hide;virtual;
    procedure GetItemRect(Item: PMenuItem; var R: TRect); virtual;
  end;


function NewItem(Name, Param: TMenuStr; KeyCode: Word; Command: Integer;
  AHelpCtx: Word; Next: PMenuItem): PMenuItem;
function NewLine(Next: PMenuItem): PMenuItem;
function NewSubMenu(Name: TMenuStr; AHelpCtx: Word; SubMenu: PMenu;
  Next: PMenuItem): PMenuItem;
function Disabled(P:PMenuItem):Boolean;
{ TMenu routines }

function NewMenu(Items: PMenuItem): PMenu;
procedure DisposeMenu(Menu: PMenu);

Const
 RMenuBar :TStreamRec = (ObjType:20;
						 VMTLink:Ofs(TypeOf(TMenuBar)^);
						 Load:@TMenuBar.Load;
						 Store:@TMenuBar.Store);

 RMenuBox :TStreamRec = (ObjType:21;
						 VMTLink:Ofs(TypeOf(TMenuBox)^);
						 Load:@TMenuBox.Load;
						 Store:@TMenuBox.Store);

Procedure RegisterMenus;

implementation
Procedure RegisterMenus;
begin
 RegisterType(RMenuBar);
 RegisterType(RMenuBox);
end;
function NewItem(Name, Param: TMenuStr; KeyCode: Word; Command:Integer;
  AHelpCtx: Word; Next: PMenuItem): PMenuItem;
var
  P: PMenuItem;
begin
  if (Name <> '') and (Command <> 0) then
  begin
    New(P);
    P^.Next := Next;
    P^.Name := NewStr(Name);
    P^.Command := Command;
    P^.KeyCode := KeyCode;
    P^.HelpCtx := AHelpCtx;
    P^.Param := NewStr(Param);
    NewItem := P;
  end else
  NewItem := Next;
end;

function NewLine(Next: PMenuItem): PMenuItem;
var
  P: PMenuItem;
begin
  New(P);
  P^.Next := Next;
  P^.Name := nil;
  P^.HelpCtx := hcNoContext;
  NewLine := P;
end;

function NewSubMenu(Name: TMenuStr; AHelpCtx: Word; SubMenu: PMenu;
  Next: PMenuItem): PMenuItem;
var
  P: PMenuItem;
begin
  if (Name <> '') and (SubMenu <> nil) then
  begin
    New(P);
    P^.Next := Next;
    P^.Name := NewStr(Name);
    P^.Command := 0;
    P^.HelpCtx := AHelpCtx;
    P^.SubMenu := SubMenu;
    NewSubMenu := P;
  end else
  NewSubMenu := Next;
end;
function Disabled(P:PMenuItem):Boolean;
begin
 Disabled:=(P^.Command<>0)and(P^.Command<255)and (P^.Command in DisabledCommands);
end;
{ TMenu routines }

function NewMenu(Items: PMenuItem): PMenu;
var
  P: PMenu;
begin
  New(P);
  P^.Items := Items;
  P^.Default := Items;
  NewMenu := P;
end;

procedure DisposeMenu(Menu: PMenu);
var
  P, Q: PMenuItem;
begin
  if Menu <> nil then
  begin
    P := Menu^.Items;
    while P <> nil do
    begin
      if P^.Name <> nil then
      begin
        DisposeStr(P^.Name);
        if P^.Command <> 0 then
          DisposeStr(P^.Param) else
          DisposeMenu(P^.SubMenu);
      end;
      Q := P;
      P := P^.Next;
      Dispose(Q);
    end;
    Dispose(Menu);
  end;
end;
constructor TMenuView.Load(var S: TStream);

function DoLoadMenu: PMenu;
var
  Item: PMenuItem;
  Last: ^PMenuItem;
  Menu: PMenu;
  Tok: Byte;
begin
  New(Menu);
  Last := @Menu^.Items;
  Item := nil;
  S.Read(Tok,1);
  while Tok <> 0 do
  begin
    New(Item);
    Last^ := Item;
    Last := @Item^.Next;
    with Item^ do
    begin
      Name := S.ReadStr;
      S.Read(Command, SizeOf(Word) * 3 + SizeOf(Boolean));
      if (Name <> nil) then
        if Command = 0 then SubMenu := DoLoadMenu
        else  Param := S.ReadStr
      else SubMenu:=Nil;
    end;
    S.Read(Tok, 1);
  end;
  Last^ := nil;
  Menu^.Default := Menu^.Items;
  DoLoadMenu := Menu;
end;

begin
  TVisibleObject.Load(S);
  Menu := DoLoadMenu;
end;
procedure TMenuView.Store(var S: TStream);

procedure DoStoreMenu(Menu: PMenu);
var
  Item: PMenuItem;
  Tok: Byte;
begin
  Tok := $FF;
  Item := Menu^.Items;
  while Item <> nil do
  begin
    with Item^ do
    begin
      S.Write(Tok, 1);
      S.WriteStr(Name);
      S.Write(Command, SizeOf(Word) * 3 + SizeOf(Boolean));
      if (Name <> nil) then
        if Command = 0 then DoStoreMenu(SubMenu)
        else S.WriteStr(Param);
    end;
    Item := Item^.Next;
  end;
  Tok := 0;
  S.Write(Tok, 1);
end;

begin
  TVisibleObject.Store(S);
  DoStoreMenu(Menu);
end;

function TMenuView.FindItem(Code:Word): PMenuItem;
var
  P: PMenuItem;
  I: Integer;
  ScanCode:Byte;
begin
  ScanCode := Hi(Code);
  P := Menu^.Items;
  while P <> nil do
  begin
    if (P^.Name <> nil) and not Disabled(P) then
    begin
      I := Pos('~', P^.Name^);
      if (I <> 0) and (ScanCode = GetScanCode(P^.Name^[i+1])) then
      begin
        FindItem := P;
        Exit;
      end;
    end;
    P := P^.Next;
  end;
  FindItem := nil;
end;

procedure TMenuView.GetItemRect(Item: PMenuItem; var R: TRect);
begin
end;

function TMenuView.GetHelpCtx: Word;
var
  C: PMenuView;
begin
  C := @Self;
  while (C <> nil) and
     ((C^.Current = nil) or (C^.Current^.HelpCtx = hcNoContext) or
      (C^.Current^.Name = nil)) do
    C := C^.ParentMenu;
  if C <> nil then GetHelpCtx := C^.Current^.HelpCtx
  else GetHelpCtx := hcNoContext;
end;
function TMenuView.HotKey(KeyCode: Word): PMenuItem;

function FindHotKey(P: PMenuItem): PMenuItem;
var
  T: PMenuItem;
begin
  while P <> nil do
  begin
    if P^.Name <> nil then
      if P^.Command = 0 then
      begin
        T := FindHotKey(P^.SubMenu^.Items);
        if T <> nil then
        begin
          FindHotKey := T;
          Exit;
        end;
      end
      else if not Disabled(p) and (P^.KeyCode <> kbNoKey) and
        (P^.KeyCode = KeyCode) then
      begin
        FindHotKey := P;
        Exit;
      end;
    P := P^.Next;
  end;
  FindHotKey := nil;
end;

begin
  HotKey := FindHotKey(Menu^.Items);
end;

function TMenuView.NewSubView(X1,Y1:Integer; AMenu: PMenu;
  AParentMenu: PMenuView): PMenuView;
begin
  NewSubView := New(PMenuBox, Init(X1,Y1, AMenu, AParentMenu));
end;

constructor TMenuBar.Init(X1,Y1,X2,Y2:Integer; AMenu: PMenu);
begin
  TMenuView.Init(X1,Y1,X2,Y2);
  Menu:=AMenu;
end;

destructor TMenuBar.Done;
begin
  TMenuView.Done;
  DisposeMenu(Menu);
end;

procedure TMenuBar.Draw;
var
  X, L: Integer;
  P: PMenuItem;
  B:String;
  SizeX:Integer;
  A:Byte;
begin
  FillChar(B[1],255,' ');
  SetFillStyle(SolidFill,ForeColor);
  Limits.Fill;
  B:='';
  SizeX:=Pred(Limits.B.X-Limits.A.X) div 8;
  if Menu <> nil then
  begin
    X := 1;
    P := Menu^.Items;
    while P <> nil do
    begin
      if P^.Name <> nil then
      begin
        L := CStrLen(P^.Name^);
        if X + L <= SizeX then
        begin
          if Disabled(P) then
            if P = Current then
              A:=taInverse+taItalic else
              A:=taItalic
               else
            if P = Current then
              A:=TaInverse else
              A:=taNormal;
           B:=B+' '+Tilda2cc(P^.Name^,A,A or taUnderline)+^B+chr(taNormal);
        end;
       inc(X,CstrLen(P^.Name^)+1);
      end;
      P := P^.Next;
    end;
  end;
  if CStrLen(B)<SizeX then Inc(B[0],SizeX-CstrLen(B));
  MoveTo(Limits.A.X,Limits.A.Y);
  Cursor^.Hide;
  SwapColors;
  DrawText(B);
  SwapColors;
  Cursor^.Show;
end;

procedure TMenuBar.GetItemRect(Item: PMenuItem; var R: TRect);
Label 1;
var
  P: PMenuItem;
begin
  R.Assign(1, Limits.A.Y, 1, Limits.B.Y);
  P := Menu^.Items;
  while True do
  begin
    R.A.X := R.B.X;
    if P^.Name <> nil then Inc(R.B.X, CStrLen(Tilda2CC(P^.Name^,taNormal,TaNormal))+1);
    if P = Item then Goto 1;
    P := P^.Next;
  end;
1:R.B.X:=R.B.X*8+Limits.A.X;
  R.A.X:=R.A.X*8+Limits.A.X;
end;
constructor TMenuBox.Init(X1,Y1:Integer; AMenu: PMenu;
  AParentMenu: PMenuView);
var
  W, H, L: Integer;
  P: PMenuItem;
  R: TRect;
begin
  W := 10;
  H := 6;
  if AMenu <> nil then
  begin
    P := AMenu^.Items;
    while P <> nil do
    begin
      if P^.Name <> nil then
      begin
        L := CStrLen(Tilda2CC(P^.Name^,taNormal,taNormal)) + 2;
        if P^.Command = 0 then Inc(L, 3) else
          if P^.Param <> nil then Inc(L, CStrLen(P^.Param^) + 2);
        if L > W then W := L;Inc(H,FontSize);
      end else
      Inc(H,3);
      P := P^.Next;
    end;
  end;
  TMenuView.Init(X1,Y1,X1+W*8,Y1+H+3);
  Menu := AMenu;
  ParentMenu := AParentMenu;
end;

procedure TMenuBox.Draw;
var
  Attr: Byte;
  Y,SizeX: Integer;
  P: PMenuItem;
  B: String;
  R: TGrRect;

begin
  Attr := taNormal;
  SetColor(ForeColor);
  Cursor^.Hide;
  if SavePtr=nil then
   begin
    SavePtr:=Limits.SaveScreen;
    SetFillStyle(SolidFill,BackColor);
    R.Copy(Limits);
    R.Grow(-1,-1);
    R.Fill;
    SetLineStyle(SolidLn,0,ThickWidth);
    R.Draw;
    Visible:=True;
   end;
  SetLineStyle(SolidLn,0,NormWidth);
  Y:=3+Limits.A.Y;
  SizeX:=(Limits.B.X-Limits.A.x-6) div 8;
  if Menu <> nil then
  begin
    P := Menu^.Items;
    while P <> nil do
    begin
      FillChar(B[1],255,' ');
      B:='';
      Attr := taNormal;
      if P^.Name = nil then
      begin Line(Limits.A.X,Y+1,Limits.B.X-1,y+1);inc(y,3)end
      else
      begin
        if Disabled(P) then
          if P = Current then
            Attr := taInverse+taItalic else
            Attr := taItalic else
          if P = Current then Attr := taInverse;
          Moveto(Limits.A.x+4,Y);
          B:=Tilda2CC(P^.Name^,Attr,Attr+taUnderline);
          Inc(B[0],SizeX-CStrLen(B));
          inc(Y,FontSize);
        if P^.Command = 0 then
          B[Length(B) - 4]:= #16 else
          if P^.Param <> nil then
            System.Move(P^.Param^[1],B[Length(B) -  Length(P^.Param^)],
              Length(P^.Param^));
      end;
      DrawText(B);
      P := P^.Next;
    end;
  end;
  Cursor^.Show;
end;

procedure TMenuBox.GetItemRect(Item: PMenuItem; var R: TRect);
var
  Y,Y2: Integer;
  P: PMenuItem;
begin
  Y := Limits.A.Y+3;
  P := Menu^.Items;
  while P <> Item do
  begin
    if P^.Name<>nil then
    Inc(Y,FontSize) else inc(Y,3);
    P := P^.Next;
  end;
   if P^.Name<>nil then Y2:=Y+FontSize else Y2:=Y+3;
  R.Assign(Limits.A.X+3, Y, Limits.B.x- 3, Y2);
end;
Procedure TMenuBox.Hide;
begin
 if SavePtr=nil then exit;
 Cursor^.Hide;
 PutImage(Limits.A.X,Limits.A.Y,SavePtr^,CopyPut);
 Cursor^.Show;
 DisposeImage(SavePtr);
 SavePtr:=nil;
end;
Destructor TMenuBox.Done;
begin
 if SavePtr<>nil then Hide;
 TMenuView.Done;
end;

function TMenuView.Execute: Word;

var Cmd,RetVal:Word;Stop:Boolean;
    P:PMenuItem;
Procedure Return(cmd:Word);
begin
 RetVal:=Cmd;
 Stop:=True;
end;
Procedure KillSubMEnu;
   begin Dispose(SubMenu,Done);SubMEnu:=nil;end;
Procedure SetCurrent;
begin
 Menu^.Default:=Current;
 Draw;
 if SubMenu<>nil then
 begin
  KillSubmenu;
  if Current^.SubMenu<>nil then OpenSubMenu;
 end;
end;
Procedure PrevItem;
var P:PMenuItem;
begin
 Repeat
  if Current=Menu^.Items then While Current^.Next<>nil do Current:=Current^.Next
  else
   begin
    P:=Menu^.Items;
    While P^.Next<>Current do P:=P^.Next;
    Current:=P;
   end
  Until Current^.Name<>nil;
  SetCurrent;
end;
Procedure NextItem;
begin
 Repeat
  if Current^.Next=nil then Current:=Menu^.Items else Current:=Current^.Next
 Until Current^.Name<>nil;
 SetCurrent;

end;

begin
  Flags:=Flags or vfExecuting;
  Current:=Menu^.Default;
  Draw;
  DisableKeyMove;
  Stop:=False;
  Repeat
   if SubMenu<>nil then
   cmd:=SubMEnu^.Execute
   else Cmd:=GetEvent;
   Case cmd of
   kbLeft:if isBar then PrevItem else
          if (ParentMenu<>nil) and ParentMenu^.isBar then Return(Cmd);
   kbRight:if isBar then NextItem else
          if (ParentMenu<>nil) and ParentMenu^.isBar then Return(Cmd);
   kbUp:If not isBar then PRevItem;
   kbDown:if not isBar then NextItem else
             if Current^.SubMenu<>nil then OpenSubMenu;
   kbEsc:Return(Word(cmEventProcessed));
   Word(cmEventProcessed):if SubMEnu<>nil then KillSubMenu;
   kbEnter:begin cmd:=SelectItem(Current);
                 if Cmd<>Word(cmEventProcessed) then Return(Cmd);
           end;
   1..255:{}begin
            if SubMenu<>nil then KillSubMenu;
            Return(Cmd);
           end;
   kbMousePressed..kbMousePressed+$FF:
          begin
           P:=FindPoint(Event);
           if P<>nil then
            begin
             Cmd:=SelectItem(P);
             if cmd<>Word(cmEventProcessed) then Return(cmd)
            end
           Else
            Return(Cmd);
          end;
   else
    P:=finditem(Cmd);
    if P<>nil then SelectItem(P)
     else
      P:=TopMenu^.HotKey(cmd);
      if P<>nil then Return(P^.command);
  end;
 Until stop;
  Execute:=RetVal;
  EnableKeyMove;
  Flags:=flags and not vfExecuting;
  Menu^.Default:=Current;
  Current:=nil;
  if isBar then Draw;
  if SubMenu<>nil then KillSubMenu;
end;

    Function TMenuView.isBar:Boolean;
    begin
     isBar:=False;
    end;
    Function TMenuBar.isBar:Boolean;
    begin
     isBar:=True;
    end;
function TMenuView.Handle(Code: Word):integer;
var
  CallDraw: Boolean;
  P: PMenuItem;

begin
  if Menu <> nil then
    case Code of
      kbMousePressed..kbMousePressed+$FF:if Limits.Contains(Event)
       then
        begin
         Handle:=SelectItem(FindPoint(event));
        end;
       cmMenu:Handle:=Execute;
        else
        begin
          Handle:=0;
          P := HotKey(Code);
          if (P <> nil) and not Disabled(P) then
          begin
            Handle := P^.Command;
          end else
          begin
           P:= FindItem(Code);
            if P<>nil then
           Handle:=SelectItem(P);
           end
        end;
    end;
end;
Function TMenuView.FindPoint(Pnt:TPoint):PMenuItem;
var P:PMenuItem; R:TRect;
begin
 P:=Menu^.Items;
 While (P<>nil) DO
  begin
    GetItemRect(P,R);
    if R.Contains(Pnt) then
     begin
      FindPoint:=P;
      exit;
     end;
    P:=P^.Next;
   end;
  FindPoint:=nil;
end;
Function TMenuView.SelectItem(Item:PMenuItem):integer;
var R:TRect;
begin
 if Item=nil then
  begin
  SelectItem:=cmEventProcessed;
  exit
  end;
 Menu^.Default:=Item;
 if Item^.Command<>0 then 
  begin
    if not Disabled(Item) then
    SelectItem:=Item^.Command 
    else SelectItem:=cmEventProcessed
  end
  else
  if Item^.Name=nil then SelectItem:=cmEventProcessed
  else
   begin
    Current:=Item;
    Draw;
    if SubMenu<>nil then Dispose(SubMenu,Done);
    OpenSubmenu;
    if Flags and vfExecuting<>0 then SelectItem:=cmEventProcessed else
    SelectItem:=Execute;
   end;
end;
Procedure TMenuView.OpenSubMenu;
var R:TRect;
begin
    GetItemRect(Current, R);
    SubMEnu := NewSubView(R.A.X+3,R.B.Y, Current^.SubMenu, @Self);
end;
Function TMenuView.TopMenu:PMenuView;
var P:PMenuView;
begin
 P:=@Self;
 While P^.ParentMenu<>nil do
  P:=P^.ParentMenu;
 TopMenu:=P;
end;
Function TMenuView.GetItemByCommand(ACommand:Integer):PMenuItem;
Function ScanItems(AItem:PMenuItem):PMenuItem;

var P,Q:PMenuItem;
begin
  P:=AItem;
  While (P<>nil)and(P^.Command<>ACommand) do
   if (P^.Command=0)and(P^.Submenu<>nil) then
    begin
     Q:=ScanItems(P^.SubMenu^.Items);
     if Q<>nil then P:=Q else P:=P^.NExt;
    end else P:=P^.Next;
  ScanItems:=P;
end;
begin
 GetItemByCommand:=ScanItems(Menu^.Items);
end;
end.
